﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization;
using System.Xml;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using ObjectManager = Styx.WoWInternals.ObjectManager;
using System.ComponentModel;

namespace FrogTagger
{
	class CustomSettings : Settings
	{
        public static readonly CustomSettings Instance = new CustomSettings();
        public static string SettingsFileLocation
        {
            get
            {
                return string.Format(CustomSettings.CharacterSettingsDirectory + @"\FrogTagger.xml");
            }
        }

        public CustomSettings()
            : base(SettingsFileLocation)
        {
        }

        [Styx.Helpers.Setting]
        [Styx.Helpers.DefaultValue(40f)]
        [Category("General")]
        [DisplayName("Pull Range")]
        [Description("Max range in yards FrogTagger will pull mobs at")]
        public float PullRange { get; set; }

        [Styx.Helpers.Setting]
        [Styx.Helpers.DefaultValue("")]
        [Category("General")]
        [DisplayName("Pull Ability 1")]
        [Description("Main ability to use for tagging.")]
        public string PullAbility1 { get; set; }

        [Styx.Helpers.Setting]
        [Styx.Helpers.DefaultValue("")]
        [Category("General")]
        [DisplayName("Pull Ability 2")]
        [Description("Second ability to be used for tagging, will be used if ability 1 is on cooldown.")]
        public string PullAbility2 { get; set; }


        [Styx.Helpers.Setting]
        [Styx.Helpers.DefaultValue(0)]
        [Category("General")]
        [DisplayName("Frog limit")]
        [Description("Plugin will stop pulling after this many frogs are attacking you. \"0\" will disable this feature.")]
        public int FrogLimit { get; set; }
	}
}
