﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

using Styx.Plugins;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Inventory;

namespace FrogTagger
{
	class FrogTagger : HBPlugin
	{
        public override string Name { get { return "FrogTagger"; } }
		public override string Author { get { return "Nuclear898"; } }
		private readonly Version _version = new Version(1, 1);
		public override Version Version { get { return _version; } }
		public override string ButtonText { get { return "Settings"; } }
		public override bool WantButton { get { return true; } }

		public static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static WoWUnit Target { get { return StyxWoW.Me.CurrentTarget; } }

        public FrogTagger()
		{
			Logging.Write("FrogTagger " + _version + " loaded");			
		}

		public override void OnButtonPress()
		{
            Form SettingsForm = new SettingsForm();
            SettingsForm.Show();
		}

		public override void Pulse()
		{
            if (SpellManager.GlobalCooldown || Me.IsDead || Me.ZoneId != 6757 || Me.IsCasting)
                return;
            if (CustomSettings.Instance.FrogLimit > 0 && AttackableUnits.Where(x => x.Name.StartsWith("Gulp Fr") && x.IsTargetingMeOrPet).Count() >= CustomSettings.Instance.FrogLimit)
                return;
            float pullRange = CustomSettings.Instance.PullRange;

            if (Target != null && Target.Distance <= pullRange && !Target.IsTagged && Target.Name.StartsWith("Gulp Fr"))
            {
                WoWSpell spell = null;
               
                if (CustomSettings.Instance.PullAbility1 != null && SpellManager.HasSpell(CustomSettings.Instance.PullAbility1))
                {
                    spell = SpellManager.Spells[CustomSettings.Instance.PullAbility1];
                    if (spell.Cooldown)
                        spell = null; //can't use spell on cd
                }
                else
                {
                    Logging.Write("FrogTagger: You do not have the spell \"" + CustomSettings.Instance.PullAbility1 + "\" please check the settings if you spelled it correctly.");
                }

                if (spell == null) //Failed to find spell or spell is on cd
                {
                    if (CustomSettings.Instance.PullAbility2 != null && CustomSettings.Instance.PullAbility2.Length > 0)
                    {
                        if (SpellManager.HasSpell(CustomSettings.Instance.PullAbility2))
                        {
                            spell = SpellManager.Spells[CustomSettings.Instance.PullAbility2];
                            if (spell.Cooldown)
                                spell = null; //can't use spell on cd
                        }
                        else
                        {
                            Logging.Write("FrogTagger: You do not have the spell \"" + CustomSettings.Instance.PullAbility2 + "\" please check the settings if you spelled it correctly.");
                        }
                    }                   
                }

                if (spell == null)
                    return;
                if (Me.IsFacing(Target) && SpellManager.CanCast(spell))
                {
                    SpellManager.Cast(spell);
                }
                else
                {
                    Target.Face();
                }
            }
            else
            {
                var viableFrogs = AttackableUnitsNearMe(pullRange).Where(t => t.HealthPercent == 100 && t.Name.StartsWith("Gulp Fr"));
                if (viableFrogs.Any())
                {
                    viableFrogs = viableFrogs.OrderBy(t => t.Distance);
                    var frog = viableFrogs.FirstOrDefault();
                    if (frog != null)
                    {
                        frog.Target();
                    }
                }
            }
		}

        public static IEnumerable<WoWUnit> AttackableUnits
        {
            get { return ObjectManager.GetObjectsOfType<WoWUnit>(true, false).Where(u => u != null && u.Attackable && u.CanSelect && !u.IsFriendly && !u.IsDead && !u.IsNonCombatPet && !u.IsCritter); }
        }

        public static IEnumerable<WoWUnit> AttackableUnitsNearTargetsLocation(float distance)
        {
            return AttackableUnitsNearUnitLocation(Target, distance);
        }

        public static IEnumerable<WoWUnit> AttackableUnitsNearUnitLocation(WoWUnit unit, float distance)
        {
            if (unit == null)
                return new List<WoWUnit>();
            WoWPoint loc = unit.Location;
            return AttackableUnits.Where(p => p == unit || p.Location.Distance(loc) <= distance);
        }

        public static IEnumerable<WoWUnit> AttackableUnitsNearMe(float distance)
        {
            WoWPoint loc = Me.Location;
            return AttackableUnits.Where(p => p.Location.Distance(loc) <= distance);
        }
	}
}
